/*  MKRWiFi010021.ins */
#include <Wire.h>
#include <SPI.h>
#include <WiFiNINA.h>
#include <RTCZero.h>
#include "arduino_secrets.h"
//please enter your sensitive data in the Secret tab/arduino_secrets.h
char ssid[] = SECRET_SSID;        // your network SSID
char pass[] = SECRET_PASS;    // your network password
int status = WL_IDLE_STATUS;
WiFiServer server(80);
RTCZero rtc;
char tary[40];
char tary2[80];
String COLOR1 = "red";
String COLOR2 = "blue";
String cr1 = COLOR1;
String cr2 = COLOR2;
int temp_data;
byte adr48 = 0x48;
float ta[4000];
int ENDP = 3999;
int setp = 0;
int rerdp = 0;
float ttdata;
int arn[10];

void setup() {
  Wire.begin();
  Serial.begin(9600);
  while (!Serial) {
  }
  if (WiFi.status() == WL_NO_MODULE) { // check for the WiFi module:
    Serial.println("Communication with WiFi module failed!");
    while (true);   // don't continue
  }
  String fv = WiFi.firmwareVersion();
  if (fv < WIFI_FIRMWARE_LATEST_VERSION) {
    Serial.println("Please upgrade the firmware");
  }
  // attempt to connect to WiFi network:
  while (status != WL_CONNECTED) {
    Serial.print("Attempting to connect to SSID: ");
    Serial.println(ssid);
    // Connect to WPA/WPA2 network. Change this line if using open or WEP network:
    status = WiFi.begin(ssid, pass);
    // wait 10 seconds for connection:
    delay(10000);
  }
  pinMode(9, OUTPUT);
  server.begin();
  // you're connected now, so print out the status:
  printWifiStatus();
  rtc.begin();        //+
  unsigned long epoch;
  int numberOfTries = 0, maxTries = 6;
  do {
    epoch = WiFi.getTime();
    numberOfTries++;
  }
  while ((epoch == 0) && (numberOfTries < maxTries));
  Serial.println(epoch);
  Serial.println(numberOfTries);
  if (numberOfTries == maxTries) {
    Serial.print("NTP unreachable!!");
    while (1);
  }
  else {
    Serial.print("Epoch received: ");
    rtc.setEpoch(epoch + 3600 * 9);
    Serial.println();
  }
  Serial.println(epoch);
  unsigned long epoch2;
  epoch2 = rtc.getEpoch();
  Serial.println(epoch2);
}

void loop() {
  WiFiClient client = server.available();   // listen for incoming clients

  if (client) {                      // if you get a client,
    Serial.println("new client");    // print a message out the serial port
    String currentLine = "";         // make a String to hold incoming data from the client
    while (client.connected()) {     // loop while the client's connected
      if (client.available()) {      // if there's bytes to read from the client,
        char c = client.read();      // read a byte, then
        Serial.write(c);             // print it out the serial monitor
        if (c == '\n') {             // if the byte is a newline character
          // if the current line is blank, you got two newline characters in a row.
          // that's the end of the client HTTP request, so send a response:
          if (currentLine.length() == 0) {
            ttdata = getlm75tempe(adr48);
            ta[setp] = ttdata;
            setp = setp + 1;
            if (setp > ENDP) {
              setp = 0;
            }
            int wsp = setp - 1;
            for (int i = 0; i <= 9; i++) {
              arn[i] = wsp;
              wsp = wsp - 1;
              if ( wsp < 1) {
                wsp = ENDP;
              }
            }

            // HTTP headers always start with a response code (e.g. HTTP/1.1 200 OK)
            // and a content-type so the client knows what's coming, then a blank line:
            sprintf(tary, "%2d/%2d/%2d %2d:%2d:%2d temp=%5.2f", rtc.getYear(), rtc.getMonth(), rtc.getDay(), \
                    rtc.getHours(), rtc.getMinutes(), rtc.getSeconds(), ttdata);
            sprintf(tary2, "%6.2f%6.2f%6.2f%6.2f%6.2f%6.2f%6.2f%6.2f%6.2f%6.2f", ta[arn[0]], ta[arn[1]], ta[arn[2]], ta[arn[3]], ta[arn[4]], \
                    ta[arn[5]], ta[arn[6]], ta[arn[7]], ta[arn[8]], ta[arn[9]]);
            client.println("HTTP/1.1 200 OK");
            client.println("Content-type:text/html");
            client.println();
            // the content of the HTTP response follows the header:
            client.print("<!DOCTYPE html> \n<html lang=\"ja\">");
            client.print("<head>");
            client.print("<meta charset=\"utf-8\"/>");
            client.print("<meta name=\"viewport\" content=\"width=device-width,initial-scale=1\">");
            client.print("<meta http-equiv='refresh' content='10'/>");
            client.print("<title>ArduinoMKRWiFiLM7506010</title>");
            client.print("</head>");
            client.print("<div style=\"text-align:left\">");
            client.println(tary);
            client.print("</div>");
            client.print("<body  style=\"text-align:center\">");
            client.print("<h1>Arduino MKR WiFi 1010 </h1>");
            client.print("<p>Click <a href=\"/H\">here</a> to turn ");
            client.print("<span style=\"color:");
            client.print(cr1 + "\">the LED </span>on pin 9 on.</p>");
            client.print("<p>Click <a href=\"/L\">here</a> to turn <span style=\"color:");
            client.print(cr2 + "\">the LED </span> on pin 9 off.</p>");
            client.print("</p>");
            client.println(tary2);
            client.print("</body>");
            // The HTTP response ends with another blank line:
            client.println();
            // break out of the while loop:
            break;

          } else {    // if you got a newline, then clear currentLine:
            currentLine = "";
          }
        } else if (c != '\r') {  // if you got anything else but a carriage return character,
          currentLine += c;      // add it to the end of the currentLine
        }

        // Check to see if the client request was "GET /H" or "GET /L":
        if (currentLine.endsWith("GET /H")) {
          digitalWrite(9, HIGH);               // GET /H turns the LED on
          cr1 = COLOR1;
          cr2 = COLOR1;
        }
        if (currentLine.endsWith("GET /L")) {
          digitalWrite(9, LOW);          // GET /L turns the LED off
          cr2 = COLOR2;
          cr1 = COLOR2;
        }
      }
    }
    // close the connection:
    client.stop();
    Serial.println("client disconnected");
  }
}

float getlm75tempe(byte adr) {
  Wire.requestFrom(adr, 2);
  while (Wire.available()) {
    temp_data = (Wire.read() << 8); // 温度レジスタの上位8ビット取得
    temp_data = temp_data + Wire.read();
  }
  return ((temp_data >> 5) * 0.125);
}

void printWifiStatus() {
  // print the SSID of the network you're attached to:
  Serial.print("SSID: ");
  Serial.println(WiFi.SSID());
  // print your board's IP address:
  IPAddress ip = WiFi.localIP();
  Serial.print("IP Address: ");
  Serial.println(ip);
  // print the received signal strength:
  long rssi = WiFi.RSSI();
  Serial.print("signal strength (RSSI):");
  Serial.print(rssi);
  Serial.println(" dBm");
}
